** lambda =0.4+0.2t for t<1 ***;
** lambda =0.6+0.3t for t<1 ***;
**   Tmax=2 ***;

%let kappa=1.5;
%let nsim=1000000;
%let seed=200;


data med3;
 array t{50} t1 - t50;
do i=1 to &nsim;
  n=0;
  tc=1;
  do j=1 to 50;
  t[j]=.;
  end;
  do while (tc<=2); 
  ** gamma X =beta*rangam(seed,alpha) has mean alpha*beta,
  ** variarance alpha*beta*beta;
    alpha=1+n+1/&kappa;
	beta = 0.5+ 0.6*(tc-1)+0.15*(tc*tc-1)+1/&kappa;
    v=  rangam(&seed,alpha)/beta;
    c= -log(uniform(&seed))/v + (0.6*tc+0.15*tc*tc);
     tc = (-0.6+sqrt(0.36+0.6*c))/0.3;
    if tc <=2 then do;
    	n=n+1;
	    t[n]=tc;
    end;
   end;
   nnn=n;
   if nnn>3 then nnn=4;
 output;
end;
run;

proc freq data=med3;
table nnn;
run;

proc means data=med3 n mean std var min max;
var n t1 t2 t3;
title "med3: mean / variance of number of events";
run;
