** lambda =0.6* gamma* t**(gamma-1)***;
** gamma =1.5;
**   Tmax=2 ***;

%let kappa=1.2;
%let gamma=1.25;
%let Tmax=2;
%let lambda=0.6;
%let nsim=1000000;
%let seed=200;


data exp;
mean = &tmax**&gamma *&lambda;
var= (&kappa * mean +1)*mean;
proc print;
title "med1: mean / variance of number of events";
run;


data med3;
 array t{50} t1 - t50;
do i=1 to &nsim;
  n=0;
  tc=0;
  do j=1 to 50;
  t[j]=.;
  end;
  do while (tc<&Tmax); 
  ** gamma X =beta*rangam(seed,alpha) has mean alpha*beta,
  ** variarance alpha*beta*beta;
    alpha=n+1/&kappa;
	beta = tc**(&gamma)*&lambda+1/&kappa;
    v=  rangam(&seed,alpha)/beta;
    c= -log(uniform(&seed))/v + tc**(&gamma)*&lambda;
    tc = (c/&lambda)**(1/&gamma);
    if tc < &Tmax then do;
    	n=n+1;
	    t[n]=tc;
    end;
   end;
   nnn=n;
   if nnn>3 then nnn=4;
 output;
end;
run;

proc freq data=med3;
table nnn;
run;

proc means data=med3 n mean std var min max;
var n t1 t2 t3;
title "med3: mean / variance of number of events";
run;
