** lambda =0.4+0.2t for t<1 ***;
** lambda =0.6 + 0.3t for t in (1,2];
**   Tmax=2 ***;

%let kappa=1.5;
%let nsim=10000000;
%let seed=200;



data med1;
 u= 1.55;
do i=1 to &nsim;
 ** gamma X =beta*rangam(seed,alpha) has mean alpha*beta,
 ** variarance alpha*beta*beta;
  v= &kappa * rangam(&seed,1/&kappa);
  n = RAND('POISSON',v*u);
*** alternative way for sample NB(u,kappa): mean u, variance u+kappa*u*u;
*  p= 1/(1+&kappa * u); ** utot=1.5;
*  n1= RAND('NEGBINOMIAL',p, 1/&kappa);
 output;
end;
run;


data med1_2 (keep= i n t);
set med1;
if n=0 then output;
else do;
do j=1 to n;
 unif =uniform(&seed *2)*1.55;
 if unif<= 0.5 then  t = (sqrt(0.16+0.4 *unif)-0.4)/0.2;
 else t=(sqrt(0.36+0.6 *(unif+0.25))-0.6)/0.3;
 output;
 end;
end;
proc sort; by i t;
run;

data med1_3;
retain order n1;
set med1_2;
by i;
if first.i then n1=0;
if .< t<=1 then n1=n1+1;
run;

data check;
set med1_3;
by i;
if last.i;
if n1=1;
keep i;
run;

data check2;
merge check (in=a) med1_3;
by i;
if a;
if n=1;
run;



data med1_4;
merge check (in=a) med1_3;
by i;
if a;
nn=n-1;
if n=1 then do; t=.; end;
else do; if t<=1 then delete;
end;
run;

data nn;
set med1_4;
by i;
if last.i;
nnn=nn;
if nnn>3 then nnn=4;
proc freq; table nnn;
title "conditional simulation: distribution of nn given 1";
run;
proc means data=nn n mean std var;
var nn;
run;

data med1_5;
set med1_4;
by i;
if t>1;
run;


data med1_5;
retain order;
set med1_5;
by i;
if first.i then order=1;
else order=order+1;
run;



data t1;
set med1_5;
if order=1;
proc means  n mean std var;
var t;
title "med1: mean / variance of first event time";
run;

data t2;
set med1_5;
if order=2;
proc means  n mean std var;
var t;
title "med1: mean / variance of second event time";
run;

data t3;
set med1_5;
if order=3;
proc means  n mean std var;
var t;
title "med1: mean / variance of third event time";
run;
