** lambda =0.5exp(0.5t) for t<1 ***;
** lambda =0.75*exp(0.5t) for t in (1,2];
**   Tmax=2 ***;

%let kappa=1.5;
%let nsim=10000000;
%let seed=200;
%let beta=0.5;
%let alpha=0.5;

data a;
alpha=&alpha;
beta=&beta;
a=exp(beta)-1;
a1=a*alpha/beta;
b=exp(2*beta)-exp(beta);
b1=b*alpha*1.5/beta;
sig=log(&kappa+1);
mid = -sig/2;
sig=sqrt(sig);


mean =a1+b1;
var = mean +(&kappa) *mean*mean;
call symput('u1',a1);
call symput('u2',b1);
call symput('mid',mid);
call symput('sig', sig);

proc print;
run;





data med2;
array t{50} t1 - t50;

do i=1 to &nsim;
  n=0;
  tc=1; 
  f= 0.75 * exp(&beta*tc)/(&beta);
  temp= 0; U=1;kkk=0;  
   do until (U<temp);
    v =  rangam(&seed,2)/(&u1);
    U=uniform(&seed);
    kkk=kkk+1;
    y=log(v);
    temp = exp(-(y+1.5*&sig*&sig)**2/(2*&sig*&sig));
  end;

  nn = RAND('POISSON',v*(&u2));
  do j=1 to 50;
  t[j]=.;
  end;
  do while (tc<=2);
    f= -log(uniform(&seed))/v +f;
    tc = log(f*(&beta)/0.75)/(&beta);  
   * f= -log(uniform(&seed))/v *&beta/0.75+ exp(&beta*tc);
   * tc = log(f)/&beta;   

    if tc <= 2 then do;
    	n=n+1;
	    t[n]=tc;
    end;
   end;
   nnn=n;
   if nnn>3 then nnn=4;
 output;
end;
run;

proc means data=med2 n mean var std min max; var n nn v kkk;run;
proc freq data=med2 ;
table nnn;
run;

proc means data=med2 n mean std var min max;
var n t1 t2 t3;
title "med2: mean / variance of number of events";
run;
